/****************************************************************************
**  SIONLIB     http://www.fz-juelich.de/jsc/sionlib                       **
*****************************************************************************
**  Copyright (c) 2008-2018                                                **
**  Forschungszentrum Juelich, Juelich Supercomputing Centre               **
**                                                                         **
**  See the file COPYRIGHT in the package base directory for details       **
****************************************************************************/

/*!
 * \cond sion_internal
 * \file
 *
 */

#ifndef SION_SION_FD_H
#define SION_SION_FD_H

#include "sion_filedesc.h"

#define SION_FILEDESCRIPTOR 11 /*!< int id -> data structure mapping (from visit library) */
#define SION_APIDESCRIPTOR 12 /*!< int id -> data structure mapping (from visit library) */

#ifdef __cplusplus
extern "C" {
#endif

int _lsion_newvcd(void *data, int type);
int _lsion_freevcd(int sid);
void *_lsion_vcdtovcon(int sid);
int _lsion_vcdtype(int sid);
int _lsion_reassignvcd(int sid, void *data, int type);

_sion_filedesc *_lsion_get_filedesc(int sid);

#ifdef __cplusplus
}
#endif

#endif

/// \endcond
